/**
 * Created by AlexanderC on 6/20/15.
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InvalidSchemaException = undefined;

var _Exception = require('./Exception');

/**
 * Thrown when DB model validation schema is missing or broken
 */
class InvalidSchemaException extends _Exception.Exception {
  /**
   * @param {Object} model
   * @param {String} errorString
   */
  constructor(model, errorString) {
    super(`deep-db model ${JSON.stringify(model)} validation schema fails: ${errorString}`);
  }
}
exports.InvalidSchemaException = InvalidSchemaException;