/**
 * Created by AlexanderC on 6/22/15.
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ObjectValidationFailedException = undefined;

var _Exception = require('./Exception');

/**
 * Thrown when object validation fails on a joi schema/model
 */
class ObjectValidationFailedException extends _Exception.Exception {
  /**
   * @param {String} schemaName
   * @param {String} error
   */
  constructor(schemaName, error) {
    super(`Object validation failed on schema ${schemaName}: ${error}`);

    this._originalError = error;
  }

  /**
   * @returns {Error}
   */
  get originalError() {
    return this._originalError;
  }
}
exports.ObjectValidationFailedException = ObjectValidationFailedException;