/**
 * Created by AlexanderC on 5/25/15.
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Joi = undefined;

var _joi = require('joi');

var _joi2 = _interopRequireDefault(_joi);

var _vogelsPolyfill = require('./vogelsPolyfill');

var _vogelsPolyfill2 = _interopRequireDefault(_vogelsPolyfill);

var _uriRegexp = require('./uriRegexp');

var _uriRegexp2 = _interopRequireDefault(_uriRegexp);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Abstraction on Joi validation expressions
 */
class Joi {
  /**
   * @returns {Object}
   */
  static get uuid() {
    return _vogelsPolyfill2.default.types.uuid();
  }

  /**
   * @returns {Object}
   */
  static get timeUUID() {
    return _vogelsPolyfill2.default.types.timeUUID();
  }

  /**
   * @returns {Object}
   */
  static get stringSet() {
    return _vogelsPolyfill2.default.types.stringSet();
  }

  /**
   * @returns {Object}
   */
  static get numberSet() {
    return _vogelsPolyfill2.default.types.numberSet();
  }

  /**
   * @returns {Object}
   */
  static get binarySet() {
    return _vogelsPolyfill2.default.types.binarySet();
  }

  /**
   * @returns {Object}
   */
  static get binary() {
    return _joi2.default.binary();
  }

  /**
   * @returns {Object}
   */
  static get number() {
    return _joi2.default.number();
  }

  /**
   * @returns {Object}
   */
  static get string() {
    return _joi2.default.string();
  }

  /**
   * @returns {Object}
   */
  static get boolean() {
    return _joi2.default.boolean();
  }

  /**
   * @returns {Object}
   */
  static get email() {
    return _joi2.default.string().email();
  }

  /**
   * @returns {Object}
   */
  static get website() {
    let strJoiObj = _joi2.default.string();

    // Fix for Joi v5.x.x
    return strJoiObj.hasOwnProperty('uri') ? strJoiObj.uri() : strJoiObj.regex(_uriRegexp2.default.createUriRegex());
  }

  /**
   * @returns {Object}
   */
  static get map() {
    return _joi2.default.object();
  }

  /**
   * @returns {*}
   */
  static get mapSet() {
    let array = _joi2.default.array();
    if (array.includes) {
      return array.includes(_joi2.default.object());
    }

    return array.items(_joi2.default.object());
  }
}
exports.Joi = Joi;