/**
 * Created by AlexanderC on 6/25/15.
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _joi = require('joi');

var _joi2 = _interopRequireDefault(_joi);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let UUID_REGEXP = /^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}$/;

/**
 * Fixes weird joi exception!
 *
 * @param {Object} proto
 * @returns {Object}
 * @private
 */
function _joiVector(proto) {
  let arr = _joi2.default.array();

  if (arr.includes) {
    return arr.includes(proto);
  }

  return arr.items(proto);
}

exports.default = typeof window !== 'undefined' ? {
  types: {
    uuid: function () {
      return _joi2.default.string().regex(UUID_REGEXP);
    },

    timeUUID: function () {
      return _joi2.default.string().regex(UUID_REGEXP);
    },

    stringSet: function () {
      return _joiVector(_joi2.default.string());
    },

    numberSet: function () {
      return _joiVector(_joi2.default.number());
    },

    binarySet: function () {
      return _joiVector(_joi2.default.string());
    }
  }
} : require('vogels');
module.exports = exports['default'];